<template>
  <section class="skill" id="skills">
    <h2 class="section__title">Скилы</h2>
    <div class="skill__container">
      <ul class="skill__categories">
        <li
          v-for="(category, i) in categories"
          class="skill__category"
          :class="category.class"
          :key="category.id"
          :ref="
            el => {
              categoryList[i] = el
            }
          "
          @click.self="showCategory($event)"
        >
          {{ category.label }}

          <ul class="skill__list">
            <li
              class="skill__item"
              :class="skill.class"
              v-for="skill in category.technologies"
              :key="skill.id"
            >
              <img
                :src="skill.icon"
                :alt="skill.label"
                v-if="!!skill.icon"
                class="skill__icon"
              />
              <p class="skill__label">{{ skill.label }}</p>
            </li>
          </ul>
        </li>
      </ul>
    </div>
  </section>
</template>

<script>
import { ref, reactive } from 'vue'
import { v4 as uuidv4 } from 'uuid'
export default {
  name: 'Skills',
  setup() {
    const categories = reactive([
      {
        id: uuidv4(),
        class: 'design active',
        label: 'Дизайн',
        technologies: [
          { id: uuidv4(), label: 'Apple Human Interface Guidelines' },
          { id: uuidv4(), label: 'Google Material Design System' },
          { id: uuidv4(), label: 'Wireframes' },
          { id: uuidv4(), label: 'Adaptive Web Desing' },
          { id: uuidv4(), label: 'Admin Panel Desing' }
        ]
      },
      {
        id: uuidv4(),
        class: 'frontend',
        label: 'Фронтенд',
        technologies: [
          {
            id: uuidv4(),
            label: 'HTML',
            icon: require('@/assets/images/icons/skills/technologies/html.svg')
          },
          {
            id: uuidv4(),
            label: 'CSS',
            icon: require('@/assets/images/icons/skills/technologies/css.svg')
          },
          {
            id: uuidv4(),
            label: 'JavaScript',
            icon: require('@/assets/images/icons/skills/technologies/js.svg')
          },
          {
            id: uuidv4(),
            label: 'VueJS',
            icon: require('@/assets/images/icons/skills/technologies/vue.svg')
          }
        ]
      },
      {
        id: uuidv4(),
        class: 'backend',
        label: 'Бекенд',
        technologies: [
          {
            id: uuidv4(),
            label: 'Go',
            icon: require('@/assets/images/icons/skills/technologies/go.svg')
          }
        ]
      },
      {
        id: uuidv4(),
        class: 'app',
        label: 'Приложения',
        technologies: [
          {
            id: uuidv4(),
            label: 'Kotlin',
            icon: require('@/assets/images/icons/skills/technologies/kotlin.svg')
          },
          {
            id: uuidv4(),
            label: 'Java',
            icon: require('@/assets/images/icons/skills/technologies/java.svg')
          },
          {
            id: uuidv4(),
            label: 'Swift',
            icon: require('@/assets/images/icons/skills/technologies/swift.svg')
          }
        ]
      },
      {
        id: uuidv4(),
        class: 'db',
        label: 'Базы данных',
        technologies: [
          {
            id: uuidv4(),
            label: 'PostgreSQL',
            icon: require('@/assets/images/icons/skills/technologies/postgre.svg')
          },
          {
            id: uuidv4(),
            label: 'SQLite',
            icon: require('@/assets/images/icons/skills/technologies/sqlite.svg')
          }
        ]
      },
      {
        id: uuidv4(),
        class: 'services',
        label: 'Сервисы',
        technologies: [
          {
            id: uuidv4(),
            label: 'Firebase',
            icon: require('@/assets/images/icons/skills/technologies/firebase.svg')
          },
          {
            id: uuidv4(),
            label: 'Google Maps',
            icon: require('@/assets/images/icons/skills/technologies/googlemaps.svg')
          },
          {
            id: uuidv4(),
            label: '2Gis Maps',
            icon: require('@/assets/images/icons/skills/technologies/gis.svg')
          },
          {
            id: uuidv4(),
            label: 'Google Analytics',
            icon: require('@/assets/images/icons/skills/technologies/googleanalytics.svg')
          },
          {
            id: uuidv4(),
            label: 'Yandex Metrica ',
            icon: require('@/assets/images/icons/skills/technologies/yandexmetrica.svg')
          },
          {
            id: uuidv4(),
            label: 'ARCore',
            icon: require('@/assets/images/icons/skills/technologies/arcore.svg')
          },
          {
            id: uuidv4(),
            label: 'Google Pay',
            icon: require('@/assets/images/icons/skills/technologies/googlepay.svg')
          },
          {
            id: uuidv4(),
            label: 'beGateway',
            icon: require('@/assets/images/icons/skills/technologies/begateway.svg')
          },
          {
            id: uuidv4(),
            label: 'Amazon Web Services',
            icon: require('@/assets/images/icons/skills/technologies/aws.svg')
          },
          {
            id: uuidv4(),
            label: 'Google Cloud Platform',
            icon: require('@/assets/images/icons/skills/technologies/gcp.svg')
          },
          {
            id: uuidv4(),
            label: 'Digital Ocean',
            icon: require('@/assets/images/icons/skills/technologies/digital-ocean.svg')
          }
        ]
      }
    ])
    const categoryList = ref([])
    const hideCategories = () => {
      categoryList.value.forEach(c => c.classList.remove('active'))
    }
    const showCategory = $event => {
      hideCategories()
      $event.target.classList.add('active')
    }
    return { categoryList, categories, showCategory }
  }
}
</script>
